﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ConsoleApplication39
{
    class Program
    {
        static void Main(string[] args)
        {
            TestStringBuilder();

            GC.Collect();
            GC.WaitForPendingFinalizers();

            long memSize = GC.GetTotalMemory(false);
            Console.WriteLine("刚开始时内存占用量: " + memSize);

            TestString();
            memSize = GC.GetTotalMemory(false);
            Console.WriteLine("执行完5w次string+后的内存占用量: " + memSize);

            GC.Collect();
            GC.WaitForPendingFinalizers();
            memSize = GC.GetTotalMemory(false);
            Console.WriteLine("GC垃圾回收后的内存占用量: " + memSize);
            Console.ReadKey();
        }

        private static void TestString()
        {
            string tradenoStr = "";
            int count = 50000;

            DateTime start = DateTime.Now;

            List<string> tradenoList = new List<string>();
            for (int i = 0; i < count; i++)
            {
                tradenoList.Add(DateTime.Now.Ticks.ToString());
            }

            for (int i = 0; i < tradenoList.Count; i++)
            {
                tradenoStr += tradenoList[i] + ",";
            }
            string ddd = tradenoStr.ToString().Substring(0, tradenoStr.Length - 1);

            TimeSpan elapsed = DateTime.Now - start;
            Console.WriteLine("普通string执行速度（秒）: " + elapsed.TotalSeconds);
            Console.ReadKey();
        }
        private static void TestStringBuilder()
        {
            StringBuilder tradenoStr = new StringBuilder();
            int count = 50000;

            DateTime start = DateTime.Now;

            List<string> tradenoList = new List<string>();
            for (int i = 0; i < count; i++)
            {
                tradenoList.Add(DateTime.Now.Ticks.ToString());
            }

            for (int i = 0; i < tradenoList.Count; i++)
            {
                tradenoStr.Append(tradenoList[i] + ",");
            }
            string ddd = tradenoStr.ToString().Substring(0, tradenoStr.Length - 1);

            TimeSpan elapsed = DateTime.Now - start;
            Console.WriteLine("StringBuilder执行速度（秒）: " + elapsed.TotalSeconds);
            
        }
    }
}
